#ontbinden van een veelterm van de 3de graad
import math
# meervoudige invoer
def mult(s):
    l=s.split(',')
    co=[]
    for i in l:co.append(float(i))
    return co
def f(x):
    return a*x**3+b*x*x+c*x+d
def dif(x):
    eps=0.000001
    return (f(x+eps)-f(x))/eps
def newton():
# eerst zoeken naar geheel getal dicht bij nulpunt, dan Newton
    x=1
    while f(x)*f(-x)>0:x=x+1
    if abs(f(x))>abs(f(-x)):x=-x
    ox=x+1
    while math.fabs(x-ox)>0.00001:
        ox=x;x=x-f(x)/dif(x)
    return x
def v(x):  
    if x>0:
        sgn='+'
    else:
        sgn=''
    return sgn+format(x,'.4f')
def vc(x):
    return "-("+format(x,'.4f')+")"
# hoofdprogramma
print('Ontbinden van een derdegraadsveelterm ax³+bx²+cx+d')
a,b,c,d=mult(input('a,b,c,d='))
x3=newton()
b=b+a*x3;c=c+b*x3 # horner
d=b*b-4*a*c
if d>0:
    root=math.sqrt(d)
    x1,x2=(-b-root)/2/a,(-b+root)/2/a
elif d==0:
    x1=x2=-b/2/a
else:
    root=math.sqrt(-d)
    x1,x2=(-b-root*(1j))/2/a,(-b+root*(1j))/2/a

print('Ontbinding =',format(a)+'(x'+v(-x3)+')',end='')
if d>0:
    print('(x'+v(-x2)+')(x'+v(-x1)+')')
else:
    print('[x'+vc(x2)+'][x'+vc(x1)+']')
    


    
    
