# regressie uitgaande van csv-bestand
import os
from math import *
from tkinter import *
def grafbereik(x):
	mi=min(x);ma=max(x);e1=int(log10(mi));e2=int(log10(ma))
	ex=max(e1,e2);gr=10**(ex-1);mi=int(mi/10**ex)*10**ex
	ma=(int(ma/10**ex)+1)*10**ex
	return mi,ma,gr
def f(x):return eval(fun)
def mult(s):
    l=s.split(',');co=[]
    for i in l:co.append(float(i))
    return co
def transx(x):return (x-xmi)*bc/(xma-xmi)
def transy(y):return hc-hc*(y-ymi)/(yma-ymi)
def oploss(u1,u2,u3,v1,v2,v3):
    d=u1*v2-u2*v1;da=u3*v2-u2*v3;db=u1*v3-u3*v1
    return [da/d,db/d]
def correlatie(xco,yco,xsom,ysom):
    teller=0;x2noemer=0;y2noemer=0
    for j in range(0,n):
        teller=teller+(xco[j]-xsom/n)*(yco[j]-ysom/n)
        x2noemer=x2noemer+(xco[j]-xsom/n)*(xco[j]-xsom/n)
        y2noemer=y2noemer+(yco[j]-ysom/n)*(yco[j]-ysom/n)
    noemer=sqrt(x2noemer*y2noemer)
    correl=teller/noemer
    voegtoe("Correlatie="+str(round(correl,nk)))
def bestand(fn):
        global titel,x
        fk=open(fn+'.csv');inh=fk.read()
        linh=inh.replace(',','.').split('\n')
        while '' in linh:linh.remove('')
        fk.close();titel=linh[1].split(';');x=[]
        for j in range(0,len(titel)):x.append([])   
        for i in  range (2,len(linh)):
            li=linh[i].split(';')
            for j in range(1,len(titel)):
                x[j].append(float(li[j]))
        xt=x[1];yt=x[2]
        return(xt,yt)
def velden():
	    voegtoe('Velden') 
	    for j in range(1,len(titel)):voegtoe(str(j)+')'+titel[j])
def voegtoe(lijn):tex.insert(INSERT,lijn+'\n')
def lijst():
    global xt,yt
    ki,kj=mult(E2.get());ki,kj=int(ki),int(kj)
    xt=x[ki];yt=x[kj]
    voegtoe(titel[ki]+':\n'+str(xt)+'\n'+titel[kj]+':\n'+str(yt))
def invoer():
    global xt,yt,n,func
#invoer gegevens    
    fw.withdraw()    
    naambestand=Lb.get(Lb.curselection())
    Label(form,text=naambestand).place(x=5,y=2)
    xt,yt=bestand(naambestand);n=len(xt)
def regressie(menukeuze):
    global lxt,lyt,n,a,b,gx,gy,sx,sy,sx2,sxy,esxy,lsx,lsy,lsxy,losxy,lsx2,tit,fun,nk
    ki,kj=mult(E2.get());ki,kj=int(ki),int(kj)
    xt=x[ki];yt=x[kj]
    lxt=[];lyt=[]
    for i in range(0,n):
        lxt.append(log(xt[i]));lyt.append(log(yt[i]))    
# de noodzakelijke sommaties berekenen
    sx=0;sy=0;sxy=0;sx2=0;lsx=0;lsy=0;lsxy=0;lsx2=0;esxy=0;esx2=0;losxy=0;sy2=0
    for j in range(0,n):
        sx=sx+xt[j];sy=sy+yt[j];sxy=sxy+xt[j]*yt[j]
        sx2=sx2+xt[j]*xt[j];esxy=esxy+xt[j]*lyt[j]
        sy2=sy2+yt[j]*yt[j]
        losxy=losxy+lxt[j]*yt[j]
        lsx=lsx+lxt[j];lsy=lsy+lyt[j];lsxy=lsxy+lxt[j]*lyt[j]
        lsx2=lsx2+lxt[j]*lxt[j]
    gx=sx/n;gy=sy/n
    cor=sqrt(n/(n-1))
    stafx=sqrt(sx2/n-gx**2)*cor
    stafy=sqrt(sy2/n-gy**2)*cor
    if menukeuze==1:
            voegtoe('Gemiddelde en standaardafwijking:')
            voegtoe(titel[ki]+'(x): '+format(gx,'.3f')+' , '+format(stafx,'.3f'))
            voegtoe(titel[kj]+'(y): '+format(gy,'.3f')+' , '+format(stafy,'.3f'))
    if menukeuze==2:
            func=vs.get();nk=3
            if func=='lineair':
                tit='Lineaire functie y=a.x+b';fun='a*x+b'
                linreg()
            elif func=='macht':
                tit='Machtsfunctie y=b.x^a';fun='b*x**a'
                machtreg()
            elif func=='expon':
                tit='Exponentiële functie y=b.a^x';fun='b*a**x'
                expreg()
            else:
                tit='Logaritmische functie y=a.ln(x)+b';fun='a*log(x)+b'
                logreg()    
def linreg():
    global a,b;a,b=oploss(sx,n,sy,sx2,sx,sxy)
# lineaire regressie
    if b>=0:sg="+"
    else:sg="-"
    voegtoe(tit+'\ny='+str(round(a,nk))+"x"+sg+str(round(abs(b),nk)))
# lineaire correlatie
    correlatie(xt,yt,sx,sy)
def machtreg():        
    ma,mb=oploss(lsx,n,lsy,lsx2,lsx,lsxy)
# machts- regressie
    global a,b;a=ma;b=e**mb
    voegtoe(tit+'\ny='+str(round(b,nk))+'*x^('+str(round(a,nk))+')')
# machts- correlatie
    correlatie(lxt,lyt,lsx,lsy)
def expreg():        
    ea,eb=oploss(sx,n,lsy,sx2,sx,esxy)
# expon- regressie
    global a,b;a=e**ea;b=e**eb
    voegtoe(tit+'\ny='+str(round(b,nk))+'*('+str(round(a,nk))+')^x')
# expon- correlatie
    correlatie(xt,lyt,sx,lsy)
def logreg():
# logar- regressie
    global a,b;a,b=oploss(lsx,n,sy,lsx2,lsx,losxy)
    if b>=0:sg="+"
    else:sg="-"
    voegtoe(tit+'\ny='+str(round(a,nk))+"*log(x)"+sg+str(round(abs(b),nk)))
# logaritmische correlatie
    correlatie(lxt,yt,lsx,sy)
def bereken(mk):
    global xmi,xma,ymi,yma,xt,yt
    C.delete(ALL)
    xmi,xma,xgr=grafbereik(xt);ymi,yma,ygr=grafbereik(yt)
    grafinfox=str(xmi)+','+str(xma)+','+str(xgr)
    grafinfoy=str(ymi)+','+str(yma)+','+str(ygr)    
    E1.delete(0,len(E1.get()));E1.insert(0,grafinfox)
    E3.delete(0,len(E3.get()));E3.insert(0,grafinfoy)
    regressie(mk)
#grafiek
#assen (indien binnen xmi_xma,ymi_yma )
    X=transx(0);line = C.create_line(X,0,X,hc,fill='blue',arrow='first') 
    Y=transy(0);line = C.create_line(0,Y,bc,Y,fill='blue',arrow='last')
#rooster 
    x =xmi
    while x<xma:
        X=transx(x);line = C.create_line(X,0,X,hc,fill='green',dash=[1,2])
        x=x+xgr
    y=ymi
    while y<yma:
    	Y=transy(y);line = C.create_line(0,Y,bc,Y,fill='green',dash=[1,2] )
    	y=y+ygr
#punten
    lis=[]
    for i in range(0,n):
        X,Y=transx(xt[i]),transy(yt[i])
        C.create_oval(X-3,Y-3,X+3,Y+3,fill='magenta')
    X,Y=transx(gx),transy(gy)
    C.create_oval(X-5,Y-5,X+5,Y+5,fill='darkred')    
#kromme
    lis=[];stap=0.1;x=xmi
    while x<xma:
        x=x+stap;y=f(x);X=transx(x);Y=transy(y)
        lis.append(X);lis.append(Y)
    line = C.create_line(lis,fill='red')
def nieuw():
     E1.delete(0,len(E1.get()));C.delete(ALL);tex.delete('1.0',END)
     Label(form,text='                       ').place(x=5,y=2)
def lijstbestanden():
    global Lb,fw
    fw=Toplevel(form);fw.geometry('170x200');fw.title('Openen')
    bd=Button(fw,text='Openen',command=invoer);bd.place(x=50,y=165)    
    cwd=os.getcwd();ld=os.listdir();mapcsv=str(cwd)
    L3=Label(fw,text=mapcsv,bg='grey89');L3.place(x=5,y=5)
    lijstcsv=[]
    for f in ld:
        fs=f.split('.')
        if len(fs)>1 and fs[1]=='csv':lijstcsv.append(fs[0])
    tupcsv=tuple(lijstcsv)
    Lb=Listbox(fw,listvariable=StringVar(value=tupcsv),selectmode='SINGLE',height=8,width=24,bg='grey89')
    Lb.place(x=5,y=25)
def sluithe():fh.withdraw()
def he():
        global fh
        fh=Toplevel(form);fh.geometry('400x250')
        bh=Button(fh,text='Ok',command=sluithe);bh.place(x=180,y=220)
        texhelp=Text(fh,bg='grey89',height=13,width=48);texhelp.place(x=2,y=2)
        hreg=open('helpreg.txt');helreg=hreg.read();hreg.close()
        texhelp.insert(INSERT,helreg+'\n')
def men():return Menu(mb,tearoff=0)
def ad(me,lab,co):me.add_command(label=lab,command=co)
#hoofdprogramma
global br,ho,hc,bc,bt,ht;sc=1
br=int(740);ho=int(470);hc=ho-40;bc=360;bt=370;bt2=85;hob=40
form=Tk();form.geometry(str(br)+'x'+str(ho));form.title('Curvefitting');form.resizable(False,False)
C = Canvas(form, bg="white", height=hc, width=bc);C.place(x=5,y=22)
Label(form,text='Min,max,grid   X:').place(x=bt2,y=2);Label(form,text=' Y:').place(x=bt2+177,y=2)
E1=Entry(form,bg='grey89');E1.place(x=bt2+100,y=2,width=70)
E3=Entry(form,bg='grey89');E3.place(x=bt2+210,y=2,width=70)
L2=Label(form,text='Kies voor de curvefitting 2 velden:',);L2.place(x=bt,y=2)
E2=Entry(form);E2.place(x=bt+190,y=2,width=40);E2.insert(0,'1,2');fun='a*x+b';a,b=0,0
tex=Text(form,bg='grey89',height=25,width=42,wrap=WORD);tex.place(x=bt,y=60)
vsb=Scrollbar(form,orient=VERTICAL,command=tex.yview,width=20)
tex['yscrollcommand']=vsb.set;vsb.pack(side=RIGHT,fill=Y)
ki=1;kj=2
def rb(func,xp,yp):
    Radiobutton(form,text=func,variable=vs,value=func).place(x=xp,y=yp)
vs=StringVar(form,'lineair')
rb('lineair',bt,30);rb('macht',bt+90,30)
rb('expon',bt+180,30);rb('logar',bt+270,30)
mb=Menu(form);fm=men();em=men();hm=men()
fm=Menu(mb,tearoff=0)
ad(fm,'Nieuw',nieuw);ad(fm,'Open',lijstbestanden)
ad(em,'Velden',velden);ad(em,'Lijsten gegevens',lijst)
ad(em,'Gemiddelde en standaardafwijking',lambda:bereken(1))
ad(em,'Curvefitting',lambda:bereken(2));ad(hm,'Help',he)
mb.add_cascade(label='Bestand',menu=fm)
mb.add_cascade(label='Bewerken',menu=em)
mb.add_cascade(label='Help',menu=hm)
form.config(menu=mb)
form.mainloop()

