# grafiek van een functie, raaklijn in een punt (met tkinter)
from math import *;from tkinter import *;from tkinter import messagebox
# meervoudige invoer
def mult(s):
    l=s.split(','); co=[]
    for i in l:co.append(float(i))
    return co
# omzetten wiskundige coördinaten x,y => schermcoördinaten X,Y
def transx(x):return (x-xmi)*breedte/(xma-xmi)
def transy(y):return hoogteC-hoogteC*(y-ymi)/(yma-ymi)
# berekenen functie en afgeleide functie
def f(x):return eval(E1.get())
def df(x):return (f(x+dx)-f(x-dx))/dx/2
# tekenen van de grafiek
def teken():
    global xmi,xma,ymi,yma
    C.delete(ALL);xmi,xma,ymi,yma=mult(E2.get())
# assen
    X=transx(0);C.create_line(X,0,X,hoogteC,fill='blue',arrow='first') 
    Y=transy(0);C.create_line(0,Y,breedte,Y,fill='blue',arrow='last') 
# rooster
    for x in range(int(xmi),int(xma+1)):
        X=transx(x);C.create_line(X,0,X,hoogteC,fill='green',dash=[1,2])
    for y in range(int(ymi),int(yma+1)):
        Y=transy(y);C.create_line(0,Y,breedte,Y,fill='green',dash=[1,2] )
# kromme
    lis=[];stap=0.05;x=xmi
    while x<xma:
        x=x+stap;y=f(x);ap(lis,x,y)
    C.create_line(lis,fill='red')
# toevoegen punt aan lijst [x1,y1,x2,y2,...] van een kromme (of rechte)
def ap(li,x,y):X=transx(x);Y=transy(y);li.append(X);li.append(Y)
#tekenen van de raaklijn
def raakl():
    # opstellen van de vergelijking
    x1=float(E3.get())
    rico=df(x1);alf=degrees(atan(rico))
    q=f(x1)-x1*rico
    # afronding
    y1R=format(f(x1),'.3f');alfR=format(alf,'.2f')
    ricoR=format(rico,'.3f');qR=format(q,'.3f')
    if q>=0:qR='+'+qR
    vgl=ricoR+'*x'+qR
    #invullen hoek,richtingscoëfficiënt,vergelijking
    for E in (E4,E5,E6,E7):wisentr(E)
    E4.insert(0,y1R);E5.insert(0,alfR);E6.insert(0,ricoR);E7.insert(0,vgl)
    # tekenen raaklijn
    teken();r=0.05
    lis=[];ap(lis,x1-r,f(x1)-r);ap(lis,x1+r,f(x1)+r)
    C.create_oval(lis,fill='black') # tekenen raakpunt
    # raaklijn met lengte 2*2: x1-lgr => x1+lgr
    lgr=2*cos(atan(rico));lis=[];x=x1-lgr;y=rico*x+q;ap(lis,x,y)
    x=x1+lgr;y=rico*x+q;ap(lis,x,y)
    C.create_line(lis,fill='blue')
    # tekenen horizontale stippellijn vanuit raakpunt
    lis=[];x=x1;y1=rico*x+q;ap(lis,x,y1);x=x1+2;ap(lis,x,y1)
    C.create_line(lis,fill='grey')
    t=-1;lis=[];hk=atan(rico)/10 # boog bvb.in 10 stukjes verdelen
    # tekenen stippelboog met pijl
    while t< 10:
        t=t+1
        x=x1+0.7*2*cos(t*hk);y=y1+0.7*2*sin(t*hk);ap(lis,x,y)
    C.create_line(lis,fill='grey',dash=[1,2],arrow='last')
    # alfa toevoegen
    X=transx(x1+0.8*2*cos(hk*4));Y=transy(y1+0.8*2*sin(hk*4))
    C.create_text(X,Y,text=alfa,fill='grey')
def info():messagebox.showinfo(tit+': info',infstr)
def wisentr(E):E.delete(0,len(E.get()))
def nieuw():
    for E in (E1,E2,E3,E4,E5,E6,E7):wisentr(E)
    C.delete(ALL)
# hoofdprogramma
dx=1E-6;alfa=chr(945);col='lightgrey';tit='Raaklijn aan de grafiek'
breedte=480;hoogte=400;hoogteC=hoogte-65;hoInv=hoogte-55;hoInv2=hoogte-25
form=Tk();form.geometry(str(breedte)+'x'+str(hoogte));form.title(tit);form.resizable(False,False)
C = Canvas(form, bg="white", height=hoogteC, width=breedte);C.pack()
Label(form,text='Functie:').place(x=5,y=hoInv)
E1=Entry(form);E1.place(x=50,y=hoInv,width=120);E1.insert(0,'sin(x)')
Label(form,text='XYmima:').place(x=170,y=hoInv)
E2=Entry(form);E2.place(x=225,y=hoInv,width=60);E2.insert(0,'-4,6,-4,4')
Label(form,text='x:').place(x=5,y=hoInv2)
E3=Entry(form);E3.place(x=20,y=hoInv2,width=25);E3.insert(0,'1')
Label(form,text='f(x)=').place(x=45,y=hoInv2)
E4=Entry(form,bg=col);E4.place(x=75,y=hoInv2,width=45)
Label(form,text=alfa+'=').place(x=115,y=hoInv2)
E5=Entry(form,bg=col);E5.place(x=135,y=hoInv2,width=45)
Label(form,text="f'(x)=tan("+alfa+')=').place(x=185,y=hoInv2)
E6=Entry(form,bg=col);E6.place(x=260,y=hoInv2,width=45)
Label(form,text='raaklijn y= ').place(x=305,y=hoInv2)
E7=Entry(form,bg=col);E7.place(x=365,y=hoInv2,width=105)
B1=Button(form,text=' Info ',command=info);B1.place(x=290,y=hoInv)
B2=Button(form,text='Curve',command=teken);B2.place(x=333,y=hoInv)
B3=Button(form,text='Raakl',command=raakl);B3.place(x=380,y=hoInv)
B4=Button(form,text='Nieuw',command=nieuw);B4.place(x=425,y=hoInv)
infstr='Grafiek van een functie en raaklijn\nVul in: functie,xmin,ymin,xmax,ymax\nen een getalwaarde voor x\n'
infstr=infstr+'Curve : de grafiek van de functie\nRaakl : vergelijking en grafiek raaklijn\n'
form.mainloop()
