# regel van de l'Hopital (met tkinter)
from math import *;from tkinter import *;from tkinter import messagebox
# meervoudige invoer
def mult(s):
    l=s.split(','); co=[]
    for i in l:co.append(float(i))
    return co
# omzetten wiskundige coördinaten x,y => schermcoördinaten X,Y
def transx(x):return (x-xmi)*breedteC/(xma-xmi)
def transy(y):return hoogteC-hoogteC*(y-ymi)/(yma-ymi)
# berekenen functie en afgeleide functie
def u(x):return eval(E0.get())
def v(x):return eval(E1.get())
def f(x):return eval(E5.get())
def g(x):return eval(E6.get())
def df(x):return (f(x+dx)-f(x-dx))/dx/2
def dg(x):return (g(x+dx)-g(x-dx))/dx/2
def st(x):
    if x==int(x):xs=str(int(x))
    else:xs=format(x,'.4f')
    if x>=0:return '+'+xs
    else:return xs
def init(Cv):
    global kl;Cv.delete(ALL);kl='black'
# assen
    X=transx(0);Cv.create_line(X,0,X,hoogteC,fill=kl,arrow='first') 
    Y=transy(0);Cv.create_line(0,Y,breedteC,Y,fill=kl,arrow='last') 
# rooster
    for x in range(int(xmi),int(xma+1)):
        X=transx(x);Cv.create_line(X,0,X,hoogteC,fill=kl,dash=[1,2])
    for y in range(int(ymi),int(yma+1)):
        Y=transy(y);Cv.create_line(0,Y,breedteC,Y,fill=kl,dash=[1,2] )
# x,y
    d=0.2;lis=[];ap(lis,xma-d,d);Cv.create_text(lis,text='x',fill=kl)
    lis=[];ap(lis,d,yma-d);Cv.create_text(lis,text='y',fill=kl)
# toevoegen punt aan lijst [x1,y1,x2,y2,...] van een kromme (of rechte)
def ap(li,x,y):X=transx(x);Y=transy(y);li.append(X);li.append(Y)
def teken(C,lis,tek,col):C.create_line(lis,fill=col);C.create_text(35,10,text=tek,fill=col)
def bereken():
    #krommen
    global xmi,xma,ymi,yma,c;xmi,xma,ymi,yma=mult(E2.get())
    us=E0.get();vs=E1.get()
    c=float(E3.get());uc=u(c);vc=v(c)
    wis(E4);E4.insert(0,st(uc)+','+st(vc))
    wis(E5);E5.insert(0,us+st(-uc))
    wis(E6);E6.insert(0,vs+st(-vc))
    for Cv in (C1,C2,C3,C4):init(Cv)
    lis1,lis2,lis3,lis4=[],[],[],[];stap=0.02;x=xmi        
    while x<xma:
        x=x+stap;ap(lis1,x,f(x));ap(lis2,x,g(x))
        if abs(g(x))>0.001:ap(lis3,x,f(x)/g(x))
        if abs(dg(x))>0.001:ap(lis4,x,df(x)/dg(x))
    yc=df(c)/dg(c)    
    li=[];ap(li,0,yc);ap(li,c,yc);ap(li,c,0)
    for C in(C3,C4):C.create_line(li,fill='red')
    teken(C1,lis1,'y=f(x)','blue');teken(C2,lis2,"y=g(x)",'magenta')
    teken(C3,lis3,'y=f(x)/g(x)','brown');teken(C4,lis4,"y=f'(x)/g'(x)",'green')    
    for C in (C1,C2,C3,C4):rondje(C,c,0,'black');prinX(C,c)
    prinY(C3,yc);prinY(C4,yc)
    rondje(C3,c,yc,'white');rondje(C4,c,yc,'black')
    rondje(C3,0,yc,'white'); rondje(C4,0,yc,'black');
    wis(E7);E7.insert(0,format(yc,'.4f'))
    return
def prinX(C,a):lis=[];ap(lis,a,-0.3);C.create_text(lis,text=format(a,'.2f'))
def prinY(C,a):lis=[];ap(lis,-0.4,a);C.create_text(lis,text=format(a,'.2f'))
def rondje(C,a,b,col):lis=[];r=0.05;ap(lis,a-r,b-r);ap(lis,a+r,b+r);C.create_oval(lis,fill=col)
def wis(E):E.delete(0,len(E.get()))
def nieuw():
    for E in (E0,E1,E2,E3,E4,E5,E6,E7):wis(E)
    for C in (C1,C2,C3,C4):C.delete(ALL)
def info():messagebox.showinfo(tit+': info',infstr)
# hoofdprogramma
tit="Regel van de l'Hopital"
dx=1E-6;breedte,hoogte=820,920;breedteC,hoogteC=400,400;lg='lightgrey'
form=Tk();form.geometry(str(breedte)+'x'+str(hoogte));form.title(tit);form.resizable(False,False)
C1=Canvas(form, bg="white", height=hoogteC, width=breedteC);C1.place(x=5,y=5)
C2=Canvas(form, bg="white", height=hoogteC, width=breedteC);C2.place(x=5,y=410)
C3=Canvas(form, bg="white", height=hoogteC, width=breedteC);C3.place(x=410,y=5)
C4=Canvas(form, bg="white", height=hoogteC, width=breedteC);C4.place(x=410,y=410)
Label(form,text='u(x):').place(x=5,y=825)
E0=Entry(form);E0.place(x=40,y=825,width=180);E0.insert(0,'x**3')
Label(form,text='v(x):').place(x=5,y=855)
E1=Entry(form);E1.place(x=40,y=855,width=180);E1.insert(0,'x**2+x')
Label(form,text='XYmima:').place(x=5,y=885)
E2=Entry(form);E2.place(x=60,y=885,width=160);E2.insert(0,'-5,7,-4,8')
Label(form,text='c:').place(x=260,y=825)
E3=Entry(form);E3.place(x=280,y=825,width=120);E3.insert(0,'1.2')
Label(form,text='u(c),v(c):').place(x=220,y=855)
E4=Entry(form,bg=lg,fg='black');E4.place(x=280,y=855,width=120)
Label(form,text="f(x)=u(x)-u(c):").place(x=430,y=825)
E5=Entry(form,bg=lg,fg='blue');E5.place(x=520,y=825,width=200)
Label(form,text='g(x)=v(x)-v(c):').place(x=430,y=855)
E6=Entry(form,bg=lg,fg='magenta');E6.place(x=520,y=855,width=200)
Label(form,text="f(c)/g(c)=0/0=onbepaald, als x→c,f(x)/g(x)→f'(c)/g'(c):").place(x=220,y=885)
E7=Entry(form,bg=lg,fg='red');E7.place(x=520,y=885,width=200)
Button(form,text="Info",command=info).place(x=750,y=825,width=60)
Button(form,text="Teken",command=bereken).place(x=750,y=855,width=60)
Button(form,text="Nieuw",command=nieuw).place(x=750,y=885,width=60)
infstr='Vul in: u(x), v(x), c en xmi,xma,ymi,yma\n'
infstr=infstr+'Als f(x)= u(x)-u(c) en g(x)= v(x)-v(c),\n'
infstr=infstr+'dan is f(c)=g(c)=0. Alhoewel f(c)/g(c)\n'
infstr=infstr+"onbepaald is, nadert f(x)/g(x) tot f'(c)/g'(c)"
form.mainloop()                                                         
                                                         
    
