# lineaire, exponentiële en machtsregressie
import math
from graphics import *
def oploss(u1,u2,u3,v1,v2,v3):
    d=u1*v2-u2*v1;da=u3*v2-u2*v3;db=u1*v3-u3*v1
    return [da/d,db/d]
def correlatie(xco,yco,xsom,ysom):
    teller=0;x2noemer=0;y2noemer=0
    for j in range(0,n):
        teller=teller+(xco[j]-xsom/n)*(yco[j]-ysom/n)
        x2noemer=x2noemer+(xco[j]-xsom/n)*(xco[j]-xsom/n)
        y2noemer=y2noemer+(yco[j]-ysom/n)*(yco[j]-ysom/n)
    noemer=math.sqrt(x2noemer*y2noemer)
    correl=teller/noemer
    print("Correlatie=",round(correl,4))
xt=[];yt=[];lxt=[];lyt=[]
n=int(input("Geef het aantal koppels getallen:"))
for j in range(0,n):
    print("Punt",j+1, end=" :")
    coo=input("x,y=").split(',')
    x=float(coo[0]);y=float(coo[1])
    xt.append(x);yt.append(y)
    lxt.append(math.log(x));lyt.append(math.log(y))
#hoofdprogramma
# de noodzakelijke sommaties berekenen
sx=0;sy=0;sxy=0;sx2=0;lsx=0;lsy=0;lsxy=0;lsx2=0;esxy=0;esx2=0
    
for j in range(0,n):
    sx=sx+xt[j];sy=sy+yt[j];sxy=sxy+xt[j]*yt[j];sx2=sx2+xt[j]*xt[j];esxy=esxy+xt[j]*lyt[j]
    lsx=lsx+lxt[j];lsy=lsy+lyt[j];lsxy=lsxy+lxt[j]*lyt[j];lsx2=lsx2+lxt[j]*lxt[j]

a,b=oploss(sx,n,sy,sx2,sx,sxy);ao,bo=a,b
ea,eb=oploss(sx,n,lsy,sx2,sx,esxy)
ma,mb=oploss(lsx,n,lsy,lsx2,lsx,lsxy)
# lineaire regressie
if b>=0:
    sg="+"
else:
    sg="-"
print("Regressierechte y=",round(a,4),"x"+sg,round(abs(b),4))
# lineaire correlatie
correlatie(xt,yt,sx,sy)
# exponentiële regressie
a=math.e**ea;b=math.e**eb
print("Exponentiele functie y=",round(b,4),"*(",round(a,4),")**x")
# exponentiële correlatie
correlatie(xt,lyt,sx,lsy)
# machtsfunctie regressie
a=ma;b=math.e**mb
print("Machtsfunctie y=",round(b,4),"*x**(",round(a,4),')')
# machtsfunctie correlatie
correlatie(lxt,lyt,lsx,lsy)
# grafiek
xmin=min(xt);xmax=int(max(xt)+1);ymin=min(yt);ymax=int(max(yt)+1)
if xmin>=0:xmin=-1
if ymin>=0:ymin=-1
grafbr=xmax-xmin;grafho=ymax-ymin;ratio=grafho/grafbr;afmet=500
win=GraphWin('Curvefitting  bl=lineair  cy=macht  ye=expon',afmet,afmet)
win.setCoords(xmin,ymin,xmax,ymax)
#assen
pl=Point(xmin,0);pr=Point(xmax,0);lix=Line(pl,pr);lix.setFill('Green')
po=Point(0,ymin);pb=Point(0,ymax);liy=Line(po,pb);liy.setFill('Green')
lix.draw(win);liy.draw(win)
#rooster
for x in range(int(xmin),int(xmax+1)):
    for y in range(int(ymin),int(ymax+1)):
        pt=Point(x,y);pt.setFill('Green');pt.draw(win)
for j in range(0,n):
    ci=Circle(Point(xt[j],yt[j]),0.025);ci.setFill('Red');ci.setWidth(5);ci.draw(win)
stap=0.01;x=0
while x<xmax:
    x=x+stap;y=ao*x+bo;pt=Point(x,y);pt.setFill('Blue');pt.draw(win)
    y=(math.e**mb)*x**a;pt=Point(x,y);pt.setFill('Cyan');pt.draw(win)
    y=(math.e**eb)*(math.e**ea)**x;pt=Point(x,y);pt.setFill('Yellow');pt.draw(win)
    


