# vlakke meetkunde 2 punten rechten cirkels
import os
import codecs
from tkinter import *
from tkinter import messagebox
from math import *
from copy import deepcopy
# algemene definities
# naam van de cirkels
sublis=['\u2080','\u2081','\u2082','\u2083','\u2084','\u2085','\u2086','\u2087','\u2088','\u2089']
nc=[];rc=[];pc=[]
for i in range(0,len(sublis)):nc.append(chr(664)+sublis[i]);rc.append('r'+sublis[i]);pc.append('R'+sublis[i])
def mult(s):
    li=s.split(',');co=[]
    for i in li:co.append(float(i))
    return co
def transx(x):return (x-xmi)*bc/(xma-xmi)
def transy(y):return hc-hc*(y-ymi)/(yma-ymi)
def gms(hoekdd):
    hoekstr=''
    gr=int(hoekdd);hoekstr=hoekstr+str(gr)+'g';decmi=60*(hoekdd-gr)
    mi=int(decmi);hoekstr=hoekstr+str(mi)+'m';decs=60*(decmi-mi)
    se=int(decs+0.5);hoekstr=hoekstr+str(se)+'s'
    return hoekstr
def stelsel2x2(u1,u2,u3,v1,v2,v3):d=u1*v2-u2*v1;da=u3*v2-u2*v3;db=u1*v3-u3*v1;return [da/d,db/d]
def foutm():h=messagebox.showinfo('Foutieve invoer','Je hebt niet de juiste gegevens ingevoerd\nInvoer wissen en verbeteren a.u.b')
def foutm2():h=messagebox.showinfo('Lege lijst','Je hebt nog geen gegevens\nCsv-bestand openen of\ngegevens manueel invoeren')
#invoer class Punt,Rechte,Vlak
class Punt:
    def __init__(self,naam,xco,yco):self.naam=naam;self.x = xco;self.y = yco
    def __repr__(self):return self.naam+'('+str(self.x)+','+str(self.y)+')'        
class Rechte:
        def __init__(self,naam,p1,p2):self.naam=naam;self.p1=p1;self.p2=p2
        def __repr__(self):return self.naam+'('+str(self.p1)+','+str(self.p2)+')'
class Cirkel:	
        def __init__(self,naam,p1,s):self.naam=naam;self.p1=p1;self.s=s
        def __repr__(self):return self.naam+'('+str(self.p1)+','+str(self.s)+')'
# csv-bestanden tonen in cwd (current working directory)
def lijstbestanden(ke):
    global Lb,fw,E5;fw=Toplevel(form);fw.geometry('195x220');fw.title('Bestand')    
    if ke=='openen':srt='csv';bd=Button(fw,text='Openen',command=invoerbestand)
    else:srt='txt';bd=Button(fw,text='Opslaan',command=opslaanbestand)
    bd.place(x=140,y=190);cwd=os.getcwd();ld=os.listdir();mapcsv=str(cwd)
    L3=Label(fw,text='Dir:'+mapcsv,bg='grey89');L3.place(x=5,y=5,width=185)
    L4=Label(fw,text='Bestand:');L4.place(x=5,y=190)
    E5=Entry(fw,bg='white');E5.place(x=55,y=190,width=80);lijstsrt=[]
    for f in ld:
        fs=f.split('.')
        if len(fs)>1 and fs[1]==srt:lijstsrt.append(fs[0])
    Lb=Listbox(fw,listvariable=StringVar(value=tuple(lijstsrt)),selectmode='SINGLE',height=9,width=30,bg='white')
    Lb.place(x=5,y=25)
def opslaanbestand():
    fw.withdraw();naambestand=E5.get();tekst=tex.get('1.0','end')
    for i in range(0,9):tekst=tekst.replace(rc[i],'r'+str(i));tekst=tekst.replace(pc[i],'R'+str(i))
    if naambestand=='':naambestand=Lb.get(Lb.curselection())
    fo=open(naambestand+'.txt','w',encoding='utf-8');fo.write(tekst);fo.close()
#gebruiker maakt keuze uit csv-bestanden
def invoerbestand():
#invoer gegevens 
    global xt,yt,n,func;fw.withdraw();naambestand=E5.get()    
    if naambestand=='':naambestand=Lb.get(Lb.curselection())
    form.title('Vlakke meetkunde (punten,rechten en cirkels): '+naambestand);bestand(naambestand)
def bestand(fn):
        global titel,x,lijstP,lijstR,lijstC,fw,p,r,c,ip,ic,ir
        fk=open(fn+'.csv');inh=fk.read();fk.close()
        linh=inh.split('\n') # linh =lijst rijen uit csv-bestand
        while '' in linh:linh.remove('')
        #lijsten opvullen met punten rechten en cirkels li[1] = kolom punten...
        lijstP=[];lijstR=[];lijstC=[];p=[];r=[];c=[];ip,ir,ic=0,0,0 # ip,ir,iv=teller aantal punten,rechten,cirkels
        for i in  range (2,len(linh)):
            li=linh[i].split(';')
            if len(li[1])>0 and li[1][0]==chr(39):li[1]=li[1][1:len(li[1])] # eventuele ' verwijderen
            if li[1].count(',')==1: 
                p_it=chr(ip+65)+'('+li[1]+')';lijstP.append(p_it) # lijstP met punt 'A(.,.)'....
                xi,yi=mult(li[1]);p.append(Punt(chr(ip+65),xi,yi));ip+=1 # p =lijst Punten (class Punt:p[0].naam='A')
        for i in  range (2,len(linh)):
            li=linh[i].split(';')         
            if li[2].count(',')==1:
                  r_it=chr(ir+97)+'('+li[2]+')';lijstR.append(r_it) # lijstR met rechte 'a(.,.)'....
                  el=li[2].split(',');p1=p[indp(el[0])];p2=p[indp(el[1])]
                  r.append(Rechte(chr(97+ir),p1,p2));ir+=1 # r =lijst Rechten (class Rechte:r[0].naam='a')
            if li[3].count(',')==1:
                el=li[3].split(',');p1=p[indp(el[0])];s=float(el[1])
                c.append(Cirkel(nc[ic],p1,s))
                c_it=nc[ic]+'('+li[3]+')';lijstC.append(c_it);ic+=1 # c =lijst Cirkels 
        fw=Toplevel(form);fw.geometry('30x440');fw.title('Lijst');toonlijst()
        Label(fw,text='Lijsten punten,\nrechten,cirkels').place(x=10,y=5)
        bh=Button(fw,text='OK',command=lambda:fw.destroy())
        bh.place(x=40,y=40)
# eventueel punten, rechten en vlakken toevoegen met de menu-optie 'invoer'
def selec():global st;st=var.get()            
def invoer():
    global Lb,fw,E10,ip,ir,iv,lijstP,lijstR,lijstC,var,st
    fw=Toplevel(form);fw.geometry('30x440');fw.title('Manuele invoer')
    Label(fw,text='(              )',bg='lightgrey').place(x=50,y=0,width=60)
    E10=Entry(fw,bg='white');E10.place(x=60,y=0,width=40)
    bd=Button(fw,text='Vul in',command=toevoegen);bd.place(x=65,y=22,height=15,width=40)
    bw=Button(fw,text='Wis',command=lambda:E10.delete(0,len(E10.get())));bw.place(x=65,y=40,height=15,width=40)
    bs=Button(fw,text='OK',command=lambda:fw.destroy());bs.place(x=65,y=58,height=15,width=40)
    keuze=['Punt','Rechte','Cirkel'];var=IntVar();st=0
    for i in range(0,3):
        rb=Radiobutton(fw,text=keuze[i],variable=var,value=i,command=selec);rb.place(x=0,y=i*20)
    toonlijst()
def toevoegen():
        global ip,ir,ic,lijstP,lijstR,lijstC;pars=E10.get();eps=0.000001        
        if st==0:
                xi,yi=mult(pars)
                if abs(xi-int(xi))+abs(yi-int(yi))<eps:xi,yi=int(xi),int(yi)                
                p.append(Punt(chr(65+ip),xi,yi));lijstP.append(p[ip]);ip+=1
        if st==1:
                el=pars.split(',');p1=p[indp(el[0])];p2=p[indp(el[1])];r.append(Rechte(chr(97+ir),p1,p2))
                lijstR.append(r[ir].naam+'('+r[ir].p1.naam+','+r[ir].p2.naam+')');ir+=1
        if st==2:
                el=pars.split(',');p1=p[indp(el[0])];s=float(el[1])
                if abs(s-int(s))<eps:s=int(s)
                c.append(Cirkel(nc[ic],p1,s))                 
                lijstC.append(c[ic].naam+'('+c[ic].p1.naam+','+str(c[ic].s)+')');ic+=1
        toonlijst()
# 3 lijsten, resp. van punten, rechten, cirkels tonen in dialoogvenster
def toonlijst():
    global LP,LR,LC,punten,rechten,cirkels;punten='';rechten='';cirkels=''
    LP=Listbox(fw,listvariable=StringVar(value=tuple(lijstP)),selectmode=MULTIPLE,height=8,width=12,bg='grey89');LP.place(x=5,y=75)
    LR=Listbox(fw,listvariable=StringVar(value=tuple(lijstR)),selectmode=MULTIPLE,height=8,width=12,bg='grey89');LR.place(x=5,y=190)
    LC=Listbox(fw,listvariable=StringVar(value=tuple(lijstC)),selectmode=MULTIPLE,height=8,width=12,bg='grey89');LC.place(x=5,y=305)
    vsb3=Scrollbar(fw,orient=VERTICAL,command=LP.yview,width=25);LP['yscrollcommand']=vsb3.set;vsb3.place(x=85,y=75)    
    vsb4=Scrollbar(fw,orient=VERTICAL,command=LR.yview,width=25);LR['yscrollcommand']=vsb4.set;vsb4.place(x=85,y=190)
    vsb5=Scrollbar(fw,orient=VERTICAL,command=LC.yview,width=25);LC['yscrollcommand']=vsb5.set;vsb5.place(x=85,y=305)
    for punt in lijstP:punten=punten+str(punt)+' '
    for recht in lijstR:rechten=rechten+str(recht)+' '
    for cirk in lijstC:cirkels=cirkels+str(cirk)+' '
def voegtoe(lijn):tex.insert(INSERT,lijn+'\n')
# helpbestand helprmtk.txt : kan met kladblok gewijzigd worden
def he():
        global fh;fh=Toplevel(form);fh.geometry('830x520');fh.title('Helptekst vlakke meetkunde')
        bh=Button(fh,text='OK',command=lambda:fh.destroy());bh.place(x=360,y=480)
        texhelp=Text(fh,bg='grey89',height=29,width=100);texhelp.place(x=5,y=2)
        hreg=open('helpvmtk2.txt');helreg=hreg.read();hreg.close();texhelp.insert(INSERT,helreg+'\n')
        vsb2=Scrollbar(fh,orient=VERTICAL,command=texhelp.yview,width=25)
        texhelp['yscrollcommand']=vsb2.set;vsb2.pack(side=RIGHT,fill='y')
# instellingen assenstelsel, parameters, lijst bij vorige grafiek, nauwkeurigheid
def inst():
    global fi,E1,E3,E4,E6,E7,E8,ci,cj,opstart,maxxyz,drxy,dryz,k,l,nwk,wkeu
    fi=Toplevel(form);fi.geometry('230x110');fi.title('Instellingen');w='white'
    Label(fi,text='minX').place(x=0,y=2);Label(fi,text='maxX').place(x=70,y=2)
    Label(fi,text='minY').place(x=0,y=25);Label(fi,text='maxY').place(x=70,y=25)
    E1=Entry(fi,bg=w);E1.place(x=35,y=2,width=30);E1.insert(0,xmi)
    E6=Entry(fi,bg=w);E6.place(x=105,y=2,width=30);E6.insert(0,xma)
    E3=Entry(fi,bg=w);E3.place(x=30,y=25,width=30);E3.insert(0,ymi)
    E4=Entry(fi,bg=w);E4.place(x=105,y=25,width=30);E4.insert(0,yma)
    Label(fi,text='param k').place(x=0,y=50)
    E7=Entry(fi,bg=w);E7.place(x=55,y=50,width=40);E7.insert(0,k)
    if opstart==0:ci=IntVar();cj=IntVar();opstart=1
    cb1=Checkbutton(fi,text='Rooster',variable=cj);cb1.place(x=135,y=0)
    cb2=Checkbutton(fi,text='Grafiek+lijst',variable=ci);cb2.place(x=135,y=25)
    L8=Label(fi,text='#decim.cijfers');L8.place(x=110,y=50)
    E8=Entry(fi,bg=w);E8.place(x=195,y=50,width=20);E8.insert(0,nwk)
    bi2=Button(fi,text='OK',command=confinst);bi2.place(x=90,y=75,width=50)
def confinst():fi.withdraw();checksel()
def checksel():
    global xmi,xma,ymi,yma,k,nwk,wkeu,rkeu
    xmi=float(E1.get());xma=float(E6.get());ymi=float(E3.get())
    yma=float(E4.get());k=float(E7.get());nwk=E8.get();wkeu=ci.get();rkeu=cj.get()
def info():
    global inf;inf=Toplevel(form);inf.geometry('140x50');inf.title('Info')
    Label(inf,text='2021 De Meester André').place(x=0,y=2)
    binf=Button(inf,text='OK',command=lambda:inf.destroy());binf.place(x=60,y=25)
# lr,lv= lijsten parametervergelijkingen van rechte en vlak
def fr(k):return eval(lr[0])
def gr(k):return eval(lr[1])
def hr(k):return eval(lr[2])
# definities i.v.m. GRAFIEKEN
def omzet(x,y):return transx(x),transy(y)
def lijn(x1,y1,x2,y2):
    global X,Y;lis=[];X,Y=omzet(x1,y1);lis.append(X);lis.append(Y);X,Y=omzet(x2,y2);lis.append(X);lis.append(Y);return lis
def roosteken():
    x=xmi
    while x<xma:
        if x!=0:line = C.create_line(lijn(x,ymi,x,yma),fill='lightgrey',dash=[1,5])
        x=x+1
    y=ymi
    while y<yma:
        if y!=0:line = C.create_line(lijn(xmi,y,xma,y),fill='lightgrey',dash=[1,5])
        y=y+1    
def tekeninit():
    global xmi,xma,ymi,yma,kmi,lmi,kma,lma,lijstfun,grafbas,ci,pos,k,wkeu,rkeu,nwk
    checksel();nieuwgrafbas=E1.get()+','+E6.get()+','+E3.get()+','+E4.get()
    nieuwgrafbas=str(xmi)+','+str(xma)+','+str(ymi)+','+str(yma)
    # indien er aan instellingen iets verandert, de grafiek wissen
    if nieuwgrafbas!=grafbas or wkeu==0:C.delete(ALL);pos=0
    grafbas=nieuwgrafbas;kmi=-4;kma=5
    if rkeu==1:roosteken()
    assen()
def graf():
    dial('Grafiek lijst:',tekengraflijst)
def tekengraflijst():
    global i,pos;lijstgr=E2.get().split(',');tekeninit()
    for j in range(0,len(lijstgr)):
        naam=lijstgr[j];soort=ord(naam[0])
        if soort<91:i=indp(naam);tekengrafp(p[i])               # als een punt: tekengrafp()
        if soort>96 and soort<123:i=indr(naam);tekengrafr(r[i]) # als een rechte: tekengrafr()
        if soort==664:i=sublis.index(naam[1]);tekengrafc(c[i])  # als een cirkel: tekengrafc()            
    if wkeu==1:pos=pos+1
    else:pos=1
    comment('Lijst: '+E2.get(),pos)
def tekengrafp(pun):
    X,Y=omzet(pun.x,pun.y);i=indp(pun.naam[0]);kl=colp[i%12]
    C.create_oval(X-2,Y-2,X+2,Y+2,fill=kl) # punt tekenen
    C.create_text(X+5,Y+5,text=pun.naam,fill=kl) # naam bijzetten
def tekengrafr(rech):
    global lr;lr=paramrech(rech.p1,rech.p2).split(',');i=indr(rech.naam[0])
    kl=colr[i%12];lis=[];X,Y=omzet(fr(kmi),gr(kmi));lis.append(X);lis.append(Y)
    X,Y=omzet(fr(kma),gr(kma));lis.append(X);lis.append(Y)
    line = C.create_line(lis,fill=kl) # rechte tekenen
    X,Y=omzet(fr(0.5),gr(0.5));C.create_text(X-5,Y+5,text=rech.naam,fill=kl) # naam bijzetten bij k=0.5
def tekengrafc(cirkel):
    R1=cirkel.s*bc/(xma-xmi);R2=cirkel.s*bc/(yma-ymi);X,Y=omzet(cirkel.p1.x,cirkel.p1.y);lis=[];t=-0.1
    i=indc(cirkel.naam);kl=colc[i%12]
    while t<2*pi:t=t+0.1;lis.append(X+R1*cos(t));lis.append(Y+R2*sin(t))
    line = C.create_line(lis,fill=kl)
    C.create_text(X+R1*0.7+5,Y+R2*0.7+5,text=cirkel.naam,fill=kl) # naam bijzetten
#assen
def assen():
    nm='X';lis=lijn(xmi,0,xma,0);X,Y=lis[2:4];line = C.create_line(lis,fill='black',arrow='last')
    C.create_text(X-8,Y+8,text=nm,fill='black')  # X
    nm='Y';lis=lijn(0,ymi,0,yma);X,Y=lis[2:4];line = C.create_line(lis,fill='black',arrow='last')
    C.create_text(X-8,Y+8,text=nm,fill='black')  # Y
    tekengrafp(oorsprong)
def comment(pt,pos):    
    C.create_text(bc/2,hc+10-15*pos,text=pt,fill='grey')
def grafr_vec():dial('Graf rechte+ricvec',tekengrafr_vec)
def tekengrafr_vec():
    global i,k,l,pos;naam=E2.get();nwk=E8.get()
    if (ord(naam) in rR):
        C.delete(ALL);tekeninit();k=float(E7.get());i =indr(naam);tekengrafr(r[i])
        rx,ry=ricvec(r[i].p1,r[i].p2);tekenvec(rx,ry);krx,kry=k*rx,k*ry
        bmina=r[i].p2.naam+'-'+r[i].p1.naam;C.create_text(X+10,Y-5,text=bmina,fill='grey')
        rx,ry=fr(k),gr(k);tekenvec(rx,ry);C.create_text(X+10,Y-5,text='P',fill='grey')
        tekenvec(r[i].p1.x,r[i].p1.y);tekengrafp(r[i].p1);tekengrafp(r[i].p2)
        tekenstip(0,0,krx,kry);tekenstip(krx,kry,rx,ry)
        ptek='P='+r[i].p1.naam+gt(k)+'*('+bmina+')';pos=1;comment(ptek,pos)
    else:foutm()
def tekenstip(x1,y1,x2,y2):line = C.create_line(lijn(x1,y1,x2,y2),fill='grey',dash=[1,2])
def tekenvec(x,y): line = C.create_line(lijn(0,0,x,y),fill='grey',arrow='last')
def tekenevrech():dial('// door P aan rech',berekev)
def berekev():
    p1,r1=E2.get().split(',');wkeu=0
    if (ord(p1) in rP) and (ord(r1) in rR):
        tekeninit();jp=indp(p1);jr=indr(r1);u,v,w=cv(r[jr].p1,r[jr].p2)
        tekengrafp(p[jp]);tekengrafr(r[jr]);pt=p[jp];rt=r[jr]
        x4,y4=pt.x+rt.p1.x-rt.p2.x,pt.y+rt.p1.y-rt.p2.y; p4=Punt('L',x4,y4);ev=Rechte('l',pt,p4);tekengrafr(ev)
        voegtoe('C.v. // rechte l uit '+p[jp].naam+' aan '+r[jr].naam + ' ('+gt(u)+'*x'+gt(v)+'*y'+gt(w)+'=0) is')
        u,v,w=cv(pt,p4);voegtoe(gt(u)+'*x'+gt(v)+'*y'+gt(w)+'=0')
    else:foutm()
def indp(x):return ord(x)-65 # index van punt,rechte,cirkel bepalen uit naam
def indr(x):return ord(x)-97
def indc(x):return sublis.index(x[1])
def nieuw():
    global lijstP,lijstR,lijstC,p,r,c,ip,ir,ic
    lijstP=[];lijstR=[];lijstC=[];p=[];r=[];C=[];ip,ir,ic=0,0,0
    tex.delete('1.0',END);wisgraf();form.title('Vlakke meetkunde (punten,rechten en cirkels): ____')
    return
def wisgraf():global pos;C.delete(ALL);pos=1
def wis():
    E2.delete(0,len(E2.get()));LP.selection_clear(0,END)
    LR.selection_clear(0,END);LC.selection_clear(0,END)
def colin(p1,p2,p3):
    b1=(p2.x-p1.x)*(p3.y-p1.y);b2=(p3.x-p1.x)*(p2.y-p1.y)
    if b1==b2:lin=1
    else:lin= 0
    return lin
# AFSTANDEN
def afstand(a,b):return 'Afstand ('+a.naam+','+b.naam+') = '+format(sqrt((a.x-b.x)**2+(a.y-b.y)**2),'.'+nwk+'f')
def afstand2(a,b):return sqrt((a.x-b.x)**2+(a.y-b.y)**2)
def afst2p():dial('Afstand 2 punten',berekenafst2p)
def berekenafst2p():
    p1,p2=E2.get().split(',');checksel()
    if (ord(p1) in rP) and (ord(p2) in rP):
        i1=indp(p1);i2=indp(p2);voegtoe(afstand(p[i1],p[i2]))
    else:foutm()
def afstpr():dial('Afstand punt,rechte',berekenafstpr)
def berekenafstpr():
    lprv=E2.get().split(',');checksel();p1=lprv[0];r1=lprv[1]
    if (ord(p1) in rP) and (ord(r1) in rR):
        ir=indr(r1);ip=indp(p1);u,v,w=cv(r[ir].p1,r[ir].p2)
        d_p_r=abs(u*p[ip].x+v*p[ip].y+w)/sqrt(u*u+v+v*v)
        voegtoe('Afstand('+p[ip].naam+','+r[ir].naam+') = '+format(d_p_r,'.'+nwk+'f'))
    else:foutm()
# HOEKEN
def hoek2p():dial('Hoek 2 punten',berekenh2p)
def berekenh2p():
    global a1,b1,a2,b2;p1,p2=E2.get().split(',')
    if (ord(p1) in rP) and (ord(p2) in rP):
        i1=indp(p1);i2=indp(p2);a1,b1=p[i1].x,p[i1].y;a2,b2=p[i2].x,p[i2].y
        hk=bepaalhoek();voegtoe('Hoek ('+p[i1].naam+','+p[i2].naam+') = '+gms(hk))
    else:foutm()
def bepaalhoek():    
    br=(a1*a2+b1*b2)/(sqrt(a1**2+b1**2)*sqrt(a2**2+b2**2));hoekdeg=degrees(acos(br))
    if hoekdeg>90:hoekdeg=180-hoekdeg
    return (hoekdeg)    
def hoek2r():dial('Hoek 2 rechten',berekenh2r)
def berekenh2r():
    global a1,b1,a2,b2;r1,r2=E2.get().split(',')
    if (ord(r1) in rR) and (ord(r2) in rR):
        jr1=indr(r1);jr2=indr(r2);a1,b1=ricvec(r[jr1].p1,r[jr1].p2);a2,b2=ricvec(r[jr2].p1,r[jr2].p2)
        hk=bepaalhoek();voegtoe('Hoek ('+r[jr1].naam+','+r[jr2].naam+') = '+gms(hk))
    else:foutm()
# VERGELIJKINGEN
def ricvec(a,b):return[b.x-a.x,b.y-a.y]
def gt(g):
    if g>=0:sg='+'
    else:sg=''
    return sg+format(g,'.'+nwk+'f')
def pd(u,p):
    pdr=''
    if u!=0:pdr=gt(u)+'*'+p
    return pdr
def paramrech(a,b):
    rx,ry=ricvec(a,b)
    return gt(a.x)+pd(rx,'k')+','+gt(a.y)+pd(ry,'k')
def parr():dial('Param.vgl.rechte',berekenparr)
def berekenparr():
    checksel();r1=E2.get()
    if (ord(r1) in rR):j=indr(r1);voegtoe('Parametervergelijking van '+r[j].naam+' is\nx,y= '+paramrech(r[j].p1,r[j].p2))
    else:foutm()
def loodlpr():dial('C.V. loodlijn P rech',berekenloodlpr)
def berekenloodlpr():
    p1,r1=E2.get().split(',');wkeu=0
    if (ord(p1) in rP) and (ord(r1) in rR):
        tekeninit();jr=indr(r1);jp=indp(p1);u,v,w=cv(r[jr].p1,r[jr].p2);wll=u*p[jp].y-v*p[jp].x
        voegtoe('C.v. loodlijn l uit '+p[jp].naam+' op '+r[jr].naam + '\n('+gt(u)+'*x'+gt(v)+'*y'+gt(w)+'=0) is')
        x,y=stelsel2x2(u,v,-w,v,-u,-wll);voegtoe(gt(v)+'*x'+gt(-u)+'*y'+gt(wll)+'=0\nSnijpunt = S'+snijp(x,y))
        vp=Punt('S',x,y);ll=Rechte('n',p[jp],vp);tekengrafp(p[jp]);tekengrafr(r[jr]);tekengrafp(vp);tekengrafr(ll)
    else:foutm()
def bissrech():dial('Bissectrice 2 rechten',berekenbissrech)
def berekenbissrech():    
    r1,r2=E2.get().split(',');tekeninit()
    if (ord(r1) in rR) and (ord(r2) in rR):
        ir1=indr(r1);ir2=indr(r2);u1,v1,w1=cv(r[ir1].p1,r[ir1].p2);u2,v2,w2=cv(r[ir2].p1,r[ir2].p2)
        voegtoe('Bissectrices van '+r[ir1].naam+' en '+r[ir2].naam+' :');tekengrafr(r[ir1]);tekengrafr(r[ir2])
        if u1*v2-u2*v1!=0:
            s2=sqrt(u2*u2+v2*v2);s1=sqrt(u1*u1+v1*v1)
            u3=s2*u1-s1*u2;v3=s2*v1-s1*v2;w3=s2*w1-s1*w2;u4=s2*u1+s1*u2;v4=s2*v1+s1*v2;w4=s2*w1+s1*w2
            voegtoe(gt(u3)+'*x'+gt(v3)+'*y'+gt(w3)+'=0');voegtoe(gt(u4)+'*x'+gt(v4)+'*y'+gt(w4)+'=0')
            x,y=stelsel2x2(u1,v1,-w1,u2,v2,-w2);voegtoe('Snijpunt = '+snijp(x,y))
            xsp,ysp=x,y;sp=Punt('S',xsp,ysp);tekengrafr(r[ir1]);tekengrafr(r[ir2]);tekengrafp(sp)
            if v3!=0:x=xsp+1;y=(-w3-u3*x)/v3
            else:y=ysp+1;x=-w3/u3
            vb1=Punt('L1',x,y);b1=Rechte('l1',sp,vb1);tekengrafr(b1)
            if v4!=0:x=xsp+1;y=(-w4-u4*x)/v4
            else:y=ysp+1;x=-w4/u4
            vb2=Punt('L2',x,y);b2=Rechte('l2',sp,vb2);tekengrafr(b2)
        else:voegtoe('Evenwijdige rechten')
    else:foutm()
def raaklpc():dial('Raakl. uit P aan cirk',berekenraaklpc)
def berekenraaklpc():
    global x1,y1,s1,x2,y2,s1,s2,jp;  p2,c1=E2.get().split(',');tekeninit()
    if (ord(p2) in rP) and (ord(c1[0])==664):
        jp=indp(p2);ic=sublis.index(c1[1]);nind=0
        x2,y2=p[jp].x,p[jp].y # coördinaten punt
        x1,y1=c[ic].p1.x,c[ic].p1.y;s1=c[ic].s # coördinaten middelpunt en straal cirkel 
        tekengrafp(p[jp]);tekengrafc(c[ic]);ant='Uit '+p[jp].naam+' aan '+c[ic].naam+' '
        A=y2-y1;B=x2-x1;C=-s1; D=A*A-C*C+B*B
        if C!=B:
            if D>0: #punt buiten cirkel
                voegtoe(ant+'zijn 2 raaklijnen')
                nind+=1;alfa=2*atan((-A+sqrt(D))/(C-B));tekenrlpc(alfa,nind)
                nind+=1;alfa=2*atan((-A-sqrt(D))/(C-B));tekenrlpc(alfa,nind)
            if D==0: #punt op cirkel
                voegtoe(ant+'is één raaklijn')
                nind+=1;alfa=2*atan(-A/(C-B));tekenrlpc(alfa,nind)
            if D<0:voegtoe(ant+'zijn geen raaklijnen.')
        if B==C:
            voegtoe(ant+'zijn 2 raaklijnen')
            nind+=1;alfa=pi;tekenrlpc(alfa,nind)
            nind+=1;alfa=2*atan(-B/A);tekenrlpc(alfa,nind)
    else:foutm()
def tekenrlpc(alfa1,i):
    xr1,yr1=x1+s1*cos(alfa1),y1+s1*sin(alfa1)
    np1=pc[i];nr=rc[i];P2=p[jp]    
    if alfa1!=0 and alfa1!=pi and p[jp].x!=xr1:
        m=(p[jp].y-yr1)/(p[jp].x-xr1);q=yr1-xr1*m
        voegtoe('Raaklijn '+rc[i]+' : y= '+gt(m)+'*x'+gt(q)) # sublis =index naam van de rechte
    elif p[jp].y==yr1 and p[jp].x==xr1 :
        m=tan(alfa1+pi/2);x2=xr1+100;y2=yr1+100*m;np2='P2';P2=Punt(np2,x2,y2)
        voegtoe('Raaklijn '+rc[i]+' : y= '+gt(m)+'*x'+gt(yr1-m*xr1))
    else:
        voegtoe('Raaklijn '+rc[i]+' : x= '+gt(xr1))
    voegtoe('Raakpunt '+pc[i]+' : ('+gt(xr1)+','+gt(yr1)+')')    
    R1=Punt(np1,xr1,yr1);r1=Rechte(nr,R1,P2);tekengrafp(R1);tekengrafr(r1)        
def raaklcc():dial('Raaklijnen 2 cirkels',berekenraaklcc)
def berekenraaklcc():
    global x1,y1,s1,x2,y2,s2,nind,A,B
    c1,c2=E2.get().split(',');tekeninit()
    if (ord(c1[0])==664) and (ord(c2[0])==664):
        ic1=sublis.index(c1[1]);ic2=sublis.index(c2[1])
        tekengrafc(c[ic1]);tekengrafc(c[ic2])
        voegtoe('Gemeenschappelijke raaklijnen van '+c[ic1].naam+' en '+c[ic2].naam)
        x1,y1,s1=c[ic1].p1.x,c[ic1].p1.y,c[ic1].s
        x2,y2,s2=c[ic2].p1.x,c[ic2].p1.y,c[ic2].s
        A=y2-y1;B=x2-x1;nind=0
        voegtoe('Uitwendig');berekenrlcc(s2-s1,0)
        voegtoe('Inwendig');berekenrlcc(-s2-s1,1)
    else:foutm()
def berekenrlcc(C,h): # h=1: bij de 2de cirkel de antisupplementaire hoek nemen
        global nind,D
        D=A*A-C*C+B*B
        if C==B:nind+=1;tekenrl(pi,pi+h*pi,nind)
        if C==B and A!=0:
            nind+=1;alfa=2*atan(-B/A);tekenrl(alfa,alfa+h*pi,nind)
        if C!=B:            
            if D>0: 
                nind+=1;alfa=2*atan((-A+sqrt(D))/(C-B));tekenrl(alfa,alfa+h*pi,nind)
                nind+=1;alfa=2*atan((-A-sqrt(D))/(C-B));tekenrl(alfa,alfa+h*pi,nind)
            if D==0: # cirkels raken
                nind+=1;alfa=2*atan(-A/(C-B));tekenrl(alfa,alfa+h*pi,nind)
def tekenrl(alfa1,alfa2,i):
    xr1,yr1=x1+s1*cos(alfa1),y1+s1*sin(alfa1) # raakpunten
    xr2,yr2=x2+s2*cos(alfa2),y2+s2*sin(alfa2)
    np1=pc[2*i-1];np2=pc[2*i];nr=rc[i] #namen raakpunten en raaklijn
    P1=Punt(np1,xr1,yr1);P2=Punt(np2,xr2,yr2)
    if D==0: # cirkels raken, ander punt P2 kiezen
        if y1==y2:P2=Punt('P2',xr1,yr1+100)
        else:P2=Punt('P2',xr1-100*sin(alfa1),yr1+100*cos(alfa1))
    if xr1!=xr2:
        m=(yr2-yr1)/(xr2-xr1);q=yr1-xr1*m
        voegtoe('Raaklijn '+rc[i]+': y= '+gt(m)+'*x'+gt(q))
    else:
        voegtoe('Raaklijn '+rc[i]+': x= '+gt(xr1))
    voegtoe('Raakpunten '+pc[2*i-1]+': ('+gt(xr1)+','+gt(yr1)+') '+pc[2*i]+': ('+gt(xr2)+','+gt(yr2)+')')
    r1=Rechte(nr,P1,P2);tekengrafp(P1);tekengrafp(P2);tekengrafr(r1)
def cv(a,b):u=b.y-a.y;v=-b.x+a.x;w=-b.y*a.x+b.x*a.y;return u,v,w
def carr():dial('C.V.van rechte',drukcv)
def drukcv():
    checksel();r1=E2.get()
    if (ord(r1) in rR):
        ir=indr(r1);u,v,w=cv(r[ir].p1,r[ir].p2)
        voegtoe('Cartesische vergelijking van de rechte '+r[ir].naam+':\n'+gt(u)+'*x'+gt(v)+'*y'+gt(w)+'=0')
    else:foutm()
def cc(p,r):u=-2*p.x;v=-2*p.y;w=p.x**2+p.y**2-r**2;return u,v,w
def carc():dial('C.V. van cirkel',drukcc)
def drukcc():
    checksel();c1=E2.get() # c1 = naam cirkel
    if ord(c1[0])==664: # als een cirkel
            i=sublis.index(c1[1]);u,v,w=cc(c[i].p1,c[i].s)
            voegtoe('Cartesische vergelijking van de cirkel '+c[i].naam+':\nx²+y²'+gt(u)+'*x'+gt(v)+'*y'+gt(w)+'=0')
    else:foutm()
def snijp(x,y):return '('+format(x,'.'+nwk+'f')+','+format(y,'.'+nwk+'f')+')'
def gegtek():voegtoe('Punten, rechten, cirkels :');voegtoe(punten);voegtoe(rechten);voegtoe(cirkels)
def seltek():dial('Lijst:info->tekst',druklijst)
def druklijst():
    global i;lijstgr=E2.get().split(',');lijstinfo=''
    for j in range(0,len(lijstgr)):
        naam=lijstgr[j];soort=ord(naam[0])
        if soort<91:lijstinfo=lijstinfo+str(p[indp(naam)])+'  '
        if soort>96 and soort<123:lijstinfo=lijstinfo+str(r[indr(naam)])+'  ' 
        if soort==664:lijstinfo=lijstinfo+str(c[indc(naam)])+'  '
    voegtoe(lijstinfo)
# SNIJPUNTEN
def discr():
    global ant,x1,x2,y1,y2;eps=0.0000001
    if v1!=0:
        m=-u1/v1;q=-w1/v1;A=1+m*m;B=2*q*m+u+m*v;C=q*q+q*v+w;D=B*B-4*A*C   
        if D<-eps:voegtoe(ant+'hebben geen snijpunten')
        elif abs(D)<eps:x1=-B/2/A;y1=m*x1+q; ant1()
        else:x1=(-B-sqrt(D))/2/A;y1=m*x1+q;x2=(-B+sqrt(D))/2/A;y2=m*x2+q;ant2()
    else: # verticale rechte
        x1=-w1/u1;A=1;B=v;C=x1*x1+u*x1+w;D=B*B-4*A*C
        if D<-eps:voegtoe(ant+'hebben geen snijpunten')
        elif abs(D)<eps:y1=-v/2;ant1()
        else:y1=(-B-sqrt(D))/2/A;y2=(-B+sqrt(D))/2/A;ant2()
def ant1():
    global ant;voegtoe(ant+'hebben 1 snijpunt (raakpunt),nl.:/nR('+format(x1,'.'+nwk+'f')+','+format(y1,'.'+nwk+'f')+')')
    tekengrafp(Punt('R',x1,y1))
def ant2():
    global ant;ant=ant+'hebben 2 snijpunten,nl:\n'
    ant=ant+'R'+sublis[1]+'('+format(x1,'.'+nwk+'f')+','+format(y1,'.'+nwk+'f')+')'
    ant=ant+'  R'+sublis[2]+'('+format(x2,'.'+nwk+'f')+','+format(y2,'.'+nwk+'f')+')';voegtoe(ant)
    tekengrafp(Punt('R'+sublis[1],x1,y1));tekengrafp(Punt('R'+sublis[2],x2,y2))
def snijprr():dial('Snijp. 2 rech:',berekensnijprr)
def berekensnijprr():
    r1,r2=E2.get().split(',');tekeninit()
    if (ord(r1) in rR) and (ord(r2) in rR):
        ir1=indr(r1);ir2=indr(r2);u1,v1,w1=cv(r[ir1].p1,r[ir1].p2);u2,v2,w2=cv(r[ir2].p1,r[ir2].p2)
        if u1*v2-u2*v1!=0:
            x,y=stelsel2x2(u1,v1,-w1,u2,v2,-w2);tekengrafp(Punt('S',x,y))
            voegtoe('Het snijpunt van '+r[ir1].naam+' en '+r[ir2].naam+' is S('+gt(x)+','+gt(y)+')')
        else:voegtoe('De rechten '+r[ir1].naam+' en '+r[ir2].naam+' zijn evenwijdig')
        tekengrafp(r[ir1].p1);tekengrafp(r[ir1].p2);tekengrafp(r[ir2].p1)
        tekengrafp(r[ir2].p2);tekengrafr(r[ir1]);tekengrafr(r[ir2])
    else:foutm()
def snijprc():dial('Snijp.rech,cirk:',berekensnijprc)
def berekensnijprc():
    global u1,v1,w1,u,v,w,ant;  tekeninit()
    r1,c1=E2.get().split(',')
    if (ord(r1) in rR) and (ord(c1[0])==664):
        ir1=indr(r1);ic1=sublis.index(c1[1]);u1,v1,w1=cv(r[ir1].p1,r[ir1].p2); u,v,w=cc(c[ic1].p1,c[ic1].s)
        ant='De rechte '+r[ir1].naam+' en de cirkel '+c[ic1].naam+' '
        discr();tekengrafr(r[ir1]);tekengrafc(c[ic1])
    else:foutm()
def snijpcc():dial('Snijp.2 cirkels:',berekensnijpcc)
def berekensnijpcc():
    global u1,v1,w1,u,v,w,ant;tekeninit()
    c1,c2=E2.get().split(',')
    if (ord(c1[0])==664) and (ord(c2[0])==664):
        ic1=sublis.index(c1[1]);ic2=sublis.index(c2[1])
        u1,v1,w1=cc(c[ic1].p1,c[ic1].s); u2,v2,w2=cc(c[ic2].p1,c[ic2].s); u1,v1,w1=u2-u1,v2-v1,w2-w1;u,v,w=u2,v2,w2
        ant='De cirkels '+c[ic1].naam+' en '+c[ic2].naam+' '
        discr();tekengrafc(c[ic1]);tekengrafc(c[ic2])
    else:foutm()
# DIALOOG
def dial(tek,com):
    global Lb,fb,E2,fw,rP,rR,rC,grafbas,params,nwk,ci,wkeu,tekvlag
    if ip==0 and ir==0 and ic==0:foutm2()
    else:
        rP=range(65,65+ip);rR=range(97,97+ir);rC=664
        fw=Toplevel(form);fw.geometry('30x440');fw.title('Dial');toonlijst()
        Label(fw,text=tek).place(x=0,y=0,width=110)
        E2=Entry(fw,bg='white');E2.place(x=5,y=20,width=95)
        bf=Button(fw,text='Vul in',command=vulin);bf.place(x=5,y=40,height=15,width=40);
        bw=Button(fw,text='Wis',command=wis);bw.place(x=60,y=40,height=15,width=40)
        bd=Button(fw,text='Calc',command=com);bd.place(x=5,y=56,height=15,width=40)
        bh=Button(fw,text='OK',command=lambda:fw.destroy());bh.place(x=60,y=56,height=15,width=40)
    return
def vulin():
    global liP,liR,liC;liP=LP.curselection();liR=LR.curselection();liC=LC.curselection()
    le=len(E2.get())
    for i in liP:
        pn=p[i].naam
        if not pn in E2.get():E2.insert(END,','+pn)
    for i in liR:
        rn=r[i].naam
        if not rn in E2.get():E2.insert(END,','+rn)
    for i in liC:
        cn=c[i].naam
        if not cn in E2.get():E2.insert(END,','+cn)
    if le==0:E2.delete(0,1)
#menu-functies
def men():return Menu(mb,tearoff=0)
def ad(me,lab,co):me.add_command(label=lab,command=co)
def cas(l,m):mb.add_cascade(label=l,menu=m)

# HOOFDPROGRAMMA
colp=['red','salmon','coral','indianred','magenta','violet','lightcoral','tomato','orangered','firebrick','darkorange','darkred']
colr=['blue','cadetblue','powderblue','royalblue','purple','cornflowerblue','cyan','steelblue','skyblue','dodgerblue','lightsteelblue','darkblue']
colc=['green','lime','aquamarine','paleturquoise','darkcyan','greenyellow','limegreen','turquoise','cyan','forestgreen','yellowgreen','darkgreen']
xmi=-10;xma=10;ymi=-10;yma=10;k=1.6;nwk='3';wkeu=0;rkeu=0;pos=1;opstart=0
grafbas=str(xmi)+','+str(xma)+','+str(ymi)+','+str(yma)
rP=range(65,91);rR=range(97,123)
sc=1;p=[];r=[];c=[];lijstP=[];lijstR=[];lijstC=[];ip=0;ir=0;ic=0;tekstf=''
oorsprong=Punt('O',0,0);br=1050;ho=525;hc=ho-10;bc=hc;bt=525
form=Tk();form.geometry(str(br)+'x'+str(ho));form.title('Vlakke meetkunde (punten,rechten en cirkels): ____')
#form.resizable(False,False)
C = Canvas(form, bg="white", height=hc, width=bc);C.place(x=2,y=2)
tex=Text(form,bg='grey89',height=32,width=60,wrap=WORD);tex.place(x=bt,y=3)
vsb=Scrollbar(form,orient=VERTICAL,command=tex.yview,width=35)
tex['yscrollcommand']=vsb.set;vsb.pack(side=RIGHT,fill='y')
#menu
mb=Menu(form);fm=men();am=men();vm=men();ex=men();hem=men();gm=men();wm=men()
ad(fm,'prc-bestand openen',lambda:lijstbestanden('openen'));ad(fm,'Manuele invoer punten,rechten,cirkels',invoer)
ad(fm,'Tekst opslaan ',lambda:lijstbestanden('opslaan'))
ad(gm,'// rechte door punt aan rechte',tekenevrech);
ad(gm,'Rechte + vectoren',grafr_vec);ad(gm,'Lijst punten,rechten,cirkels',graf);ad(gm,'Snijpunt 2 rechten',snijprr)
ad(gm,'Snijpunten van rechte en cirkel',  snijprc);ad(gm,'Snijpunten van 2 cirkels',  snijpcc)
ad(gm,'C.V.raaklijn uit punt aan cirkel',raaklpc);ad(gm,'C.V.raaklijnen aan 2 cirkels',raaklcc)
ad(am,'Afstand 2 punten',afst2p);ad(am,'Afstand punt rechte',afstpr)
ad(am,'Hoek 2 punten',hoek2p);ad(am,'Hoek 2 rechten',hoek2r)
ad(vm,'Parametervergelijkingen rechte',parr);ad(vm,'Cart. vergelijking rechte',carr)
ad(gm,'C.V. bissectrices 2 rechten',bissrech);ad(gm,'C.V. loodlijn punt op rechte',loodlpr)
ad(vm,'Cart. vergelijking cirkel',carc);
ad(wm,'Wis grafiek',wisgraf);ad(wm,'Wis tekst',lambda:tex.delete('1.0',END));ad(wm,'Nieuw',nieuw)
ad(ex,'Instellingen',inst);ad(ex,'Geselecteerde lijst gegevens -->tekst',seltek);ad(ex,'Volledige lijst gegevens -->tekst',gegtek);ad(hem,'Help',he);ad(hem,'Info',info)
cas('Bestand',fm);cas('Grafiek',gm);cas('Vergelijkingen',vm)
cas('Afstand-hoek',am);cas('Wissen',wm);cas('Extra',ex);cas('Help',hem)
form.config(menu=mb)
inst();fi.withdraw()
form.mainloop()

